Subject: Re: regarding kgdb in ppc

From: sudheer <[email-masked]>
Date: Sat, 30 Dec 2006 16:57:35 +0530

Vijay Sampath wrote:
>> >  I have checked all the above and are enabled in the config.  I 
>> have tried
>> > changing the kernel command line argumnets.
>> >
>> >  I get the same error saying:  (All from init/main.c)
>> >  ----
>> >  unable to open an initial console
>> >  No init found.  Try passing init= option to kernel.
>
> You need to pass init=/path/to/initprogram and console=ttySx,9600n81
> or something similar. This will however only work if you have
> configured your root filesystem correctly. This could be a ramdisk,
> harddisk partition, flash or nfs. The method for doing each is
> different.
>
>> >  I am getting the following error:
>> >
>> >  root@localhost sudheer]# /opt/eldk-3.1.1/usr/bin/ppc_85xx-gdb vmlinux
>> >  GNU gdb Red Hat Linux (6.3.0.0-1.21_1rh)
>> >  ...
>> >  This GDB was configured as "--host=i386-redhat-linux 
>> --target=ppc-linux"...
>> >  (gdb) set remotebaud 115200
>> >  (gdb) target remote /dev/ttyS0
>> >  Remote debugging using /dev/ttyS0
>> >  Ignoring packet error, continuing...
>
> This probably means that gdb on host could not communicate with the
> gdb stub on target. To ensure target is running gdb stub, connect a
> terminal program (example minicom on /dev/ttyS0) and ensure you are
> getting output similar to this line: "$T0740:30300a00;01:c0621fb0;#45"
>
> If you are getting this output, you should be able to close the
> terminal program and connect gdb using the same serial port. If you
> are not getting this output, then there could be many things wrong.
> Did you try passing the kgdb=halt argument to the kernel.
>
> Vijay
>
Vijay, Thanks  for the reply.
But before trying these options i want to clear one more issue.
While booting the kgdb kernel the kernel claims "kgdb initialisation 
failure." I have observed it very lately.

Memory CAM mapping: CAM0=256Mb, CAM1=0Mb, CAM2=0Mb residual: 0Mb
Linux version 2.6.15.5 (root@Sudheer) (gcc version 3.4.4) #2 Fri Dec 29 17:58:40 IST
2006
KGDB cannot initialize I/O yet.
Invalid syntax for option kgdb8250=
Malformed early option 'kgdb8250'
Built 1 zonelists
Kernel command line: console=ttyS0,115200 root=/dev/ram rw kgdbwait kgdb8250=0,115200
OpenPIC Version 1.2 (1 CPUs and 60 IRQ sources) at fcfbb000
PID hash table entries: 2048 (order: 11, 32768 bytes)
Dentry cache hash table entries: 65536 (order: 6, 262144 bytes)

I have changed the kgdb8250 arg to 1,0, but the result is same.
And ......
I have checked the serial cable NULL Mode connecting  x86 systems 
serially- with Cat and echo and this is fine.
When i try with Unpatched kernel on target and host(x86) - cat < 
/dev/ttyS0 doesnt wait  and returns to prompt.
I tried with 2.6.13 and 2.6.15.5 with resepective kgdb patches, but the 
result is same (kgdb Initialization failure). I am not sure where  am 
doing the mistake.
Please guide me in right way and also please let me know if any  more 
details are required.
Happy New Year in Advance.

Thanks
Sudheer